commit 6a315ce840a334d5872701f18cdcb5031a580cc8
Author: Tambet Ingo <tambet@gmail.com>
Date:   Tue Feb 10 12:19:51 2009 +0200

    Fix DBus permissions.

diff --git a/callouts/nm-avahi-autoipd.conf b/callouts/nm-avahi-autoipd.conf
index 97d9ff5..485ab42 100644
--- a/callouts/nm-avahi-autoipd.conf
+++ b/callouts/nm-avahi-autoipd.conf
@@ -4,11 +4,10 @@
 <busconfig>
         <policy user="root">
                 <allow own="org.freedesktop.nm_avahi_autoipd"/>
-                <allow send_interface="org.freedesktop.nm_avahi_autoipd"/>
         </policy>
         <policy context="default">
                 <deny own="org.freedesktop.nm_avahi_autoipd"/>
-                <deny send_interface="org.freedesktop.nm_avahi_autoipd"/>
+                <deny send_destination="org.freedesktop.nm_avahi_autoipd"/>
         </policy>
 </busconfig>
 
diff --git a/callouts/nm-dhcp-client.conf b/callouts/nm-dhcp-client.conf
index 515a110..0aeae60 100644
--- a/callouts/nm-dhcp-client.conf
+++ b/callouts/nm-dhcp-client.conf
@@ -4,11 +4,10 @@
 <busconfig>
         <policy user="root">
                 <allow own="org.freedesktop.nm_dhcp_client"/>
-		<allow send_interface="org.freedesktop.nm_dhcp_client"/>
         </policy>
         <policy context="default">
                 <deny own="org.freedesktop.nm_dhcp_client"/>
-		<deny send_interface="org.freedesktop.nm_dhcp_client"/>
+		<deny send_destination="org.freedesktop.nm_dhcp_client"/>
         </policy>
 </busconfig>
 
diff --git a/callouts/nm-dispatcher.conf b/callouts/nm-dispatcher.conf
index 32833a7..fd2f0e5 100644
--- a/callouts/nm-dispatcher.conf
+++ b/callouts/nm-dispatcher.conf
@@ -4,11 +4,11 @@
 <busconfig>
 	<policy user="root">
 		<allow own="org.freedesktop.nm_dispatcher"/>
-		<allow send_interface="org.freedesktop.nm_dispatcher"/>
+		<allow send_destination="org.freedesktop.nm_dispatcher"/>
     </policy>
     <policy context="default">
 		<deny own="org.freedesktop.nm_dispatcher"/>
-		<deny send_interface="org.freedesktop.nm_dispatcher"/>
+		<deny send_destination="org.freedesktop.nm_dispatcher"/>
     </policy>
 </busconfig>
 
diff --git a/src/NetworkManager.conf b/src/NetworkManager.conf
index 01dfee2..bb1c771 100644
--- a/src/NetworkManager.conf
+++ b/src/NetworkManager.conf
@@ -5,24 +5,22 @@
         <policy user="root">
                 <allow own="org.freedesktop.NetworkManager"/>
                 <allow send_destination="org.freedesktop.NetworkManager"/>
-                <allow send_interface="org.freedesktop.NetworkManager"/>
 
-		<allow own="org.freedesktop.NetworkManager.PPP"/>
-                <allow send_destination="org.freedesktop.NetworkManager.PPP"/>
-                <allow send_interface="org.freedesktop.NetworkManager.PPP"/>
+                <allow send_destination="org.freedesktop.NetworkManager"
+                       send_interface="org.freedesktop.NetworkManager.PPP"/>
         </policy>
         <policy at_console="true">
                 <allow send_destination="org.freedesktop.NetworkManager"/>
-                <allow send_interface="org.freedesktop.NetworkManager"/>
+
+                <deny send_destination="org.freedesktop.NetworkManager"
+                      send_interface="org.freedesktop.NetworkManager.PPP"/>
         </policy>
         <policy context="default">
                 <deny own="org.freedesktop.NetworkManager"/>
                 <deny send_destination="org.freedesktop.NetworkManager"/>
-                <deny send_interface="org.freedesktop.NetworkManager"/>
 
-                <deny own="org.freedesktop.NetworkManager.PPP"/>
-                <deny send_destination="org.freedesktop.NetworkManager.PPP"/>
-                <deny send_interface="org.freedesktop.NetworkManager.PPP"/>
+                <deny send_destination="org.freedesktop.NetworkManager"
+                      send_interface="org.freedesktop.NetworkManager.PPP"/>
         </policy>
 
         <limit name="max_replies_per_connection">512</limit>
diff --git a/system-settings/src/nm-system-settings.conf b/system-settings/src/nm-system-settings.conf
index 10184ba..ab239ce 100644
--- a/system-settings/src/nm-system-settings.conf
+++ b/system-settings/src/nm-system-settings.conf
@@ -6,17 +6,15 @@
 		<allow own="org.freedesktop.NetworkManagerSystemSettings"/>
 
 		<allow send_destination="org.freedesktop.NetworkManagerSystemSettings"/>
-		<allow send_interface="org.freedesktop.NetworkManagerSettings"/>
-		<allow send_interface="org.freedesktop.NetworkManagerSettings.Secrets"/>
 	</policy>
 	<policy context="default">
 		<deny own="org.freedesktop.NetworkManagerSystemSettings"/>
 
 		<allow send_destination="org.freedesktop.NetworkManagerSystemSettings"/>
-		<allow send_interface="org.freedesktop.NetworkManagerSettings"/>
 
 		<!-- Only root can get secrets -->
-		<deny send_interface="org.freedesktop.NetworkManagerSettings.Secrets"/>
+		<deny send_destination="org.freedesktop.NetworkManagerSystemSettings"
+		      send_interface="org.freedesktop.NetworkManagerSettings.Secrets"/>
 	</policy>
 
         <limit name="max_replies_per_connection">512</limit>