Index: NetworkManager-0.7.0/policy/org.freedesktop.network-manager-settings.system.policy
===================================================================
--- NetworkManager-0.7.0.orig/policy/org.freedesktop.network-manager-settings.system.policy
+++ NetworkManager-0.7.0/policy/org.freedesktop.network-manager-settings.system.policy
@@ -18,4 +18,154 @@
     </defaults>
   </action>
 
+  <action id="org.freedesktop.network-manager-settings.system.wired.modify">
+    <description>Modify system wired connections</description>
+    <message>System policy prevents modification of system wired connections</message>
+    <vendor>NetworkManager Novell Inc.</vendor>
+    <defaults>
+      <allow_inactive>no</allow_inactive>
+      <allow_active>auth_admin_keep_always</allow_active>
+    </defaults>
+  </action>
+
+  <action id="org.freedesktop.network-manager-settings.system.wireless.modify">
+    <description>Modify system wired connections</description>
+    <message>System policy prevents modification of system wired connections</message>
+    <vendor>NetworkManager Novell Inc.</vendor>
+    <defaults>
+      <allow_inactive>no</allow_inactive>
+      <allow_active>auth_admin_keep_always</allow_active>
+    </defaults>
+  </action>
+
+  <action id="org.freedesktop.network-manager-settings.system.mobile.modify">
+    <description>Modify system mobile connections</description>
+    <message>System policy prevents modification of system mobile connections</message>
+    <vendor>NetworkManager Novell Inc.</vendor>
+    <defaults>
+      <allow_inactive>no</allow_inactive>
+      <allow_active>auth_admin_keep_always</allow_active>
+    </defaults>
+  </action>
+
+  <action id="org.freedesktop.network-manager-settings.system.vpn.modify">
+    <description>Modify system vpn connections</description>
+    <message>System policy prevents modification of system vpn connections</message>
+    <vendor>NetworkManager Novell Inc.</vendor>
+    <defaults>
+      <allow_inactive>no</allow_inactive>
+      <allow_active>auth_admin_keep_always</allow_active>
+    </defaults>
+  </action>
+
+  <action id="org.freedesktop.network-manager-settings.system.dsl.modify">
+    <description>Modify system dsl connections</description>
+    <message>System policy prevents modification of system dsl connections</message>
+    <vendor>NetworkManager Novell Inc.</vendor>
+    <defaults>
+      <allow_inactive>no</allow_inactive>
+      <allow_active>auth_admin_keep_always</allow_active>
+    </defaults>
+  </action>
+
+  <action id="org.freedesktop.network-manager-settings.user.wired.apply">
+    <description>Apply user wired connections</description>
+    <message>System policy prevents using of user wired connections</message>
+    <vendor>NetworkManager Novell Inc.</vendor>
+    <defaults>
+      <allow_inactive>no</allow_inactive>
+      <allow_active>yes</allow_active>
+    </defaults>
+  </action>
+
+  <action id="org.freedesktop.network-manager-settings.user.wireless.apply">
+    <description>Apply user wireless connections</description>
+    <message>System policy prevents using of user wireless connections</message>
+    <vendor>NetworkManager Novell Inc.</vendor>
+    <defaults>
+      <allow_inactive>no</allow_inactive>
+      <allow_active>yes</allow_active>
+    </defaults>
+  </action>
+
+  <action id="org.freedesktop.network-manager-settings.user.mobile.apply">
+    <description>Apply user mobile connections</description>
+    <message>System policy prevents using of user mobile connections</message>
+    <vendor>NetworkManager Novell Inc.</vendor>
+    <defaults>
+      <allow_inactive>no</allow_inactive>
+      <allow_active>yes</allow_active>
+    </defaults>
+  </action>
+
+  <action id="org.freedesktop.network-manager-settings.user.vpn.apply">
+    <description>Apply user vpn connections</description>
+    <message>System policy prevents using of user vpn connections</message>
+    <vendor>NetworkManager Novell Inc.</vendor>
+    <defaults>
+      <allow_inactive>no</allow_inactive>
+      <allow_active>yes</allow_active>
+    </defaults>
+  </action>
+
+  <action id="org.freedesktop.network-manager-settings.user.dsl.apply">
+    <description>Apply user dsl connections</description>
+    <message>System policy prevents using of user dsl connections</message>
+    <vendor>NetworkManager Novell Inc.</vendor>
+    <defaults>
+      <allow_inactive>no</allow_inactive>
+      <allow_active>yes</allow_active>
+    </defaults>
+  </action>
+
+  <action id="org.freedesktop.network-manager-settings.user.wired.apply-with-share">
+    <description>Apply user wired connections</description>
+    <message>System policy prevents using of user wired connections</message>
+    <vendor>NetworkManager Novell Inc.</vendor>
+    <defaults>
+      <allow_inactive>no</allow_inactive>
+      <allow_active>auth_admin_keep_always</allow_active>
+    </defaults>
+  </action>
+
+  <action id="org.freedesktop.network-manager-settings.user.wireless.apply-with-share">
+    <description>Apply user wireless connections</description>
+    <message>System policy prevents using of user wireless connections</message>
+    <vendor>NetworkManager Novell Inc.</vendor>
+    <defaults>
+      <allow_inactive>no</allow_inactive>
+      <allow_active>auth_admin_keep_always</allow_active>
+    </defaults>
+  </action>
+
+  <action id="org.freedesktop.network-manager-settings.user.mobile.apply-with-share">
+    <description>Apply user mobile connections</description>
+    <message>System policy prevents using of user mobile connections</message>
+    <vendor>NetworkManager Novell Inc.</vendor>
+    <defaults>
+      <allow_inactive>no</allow_inactive>
+      <allow_active>auth_admin_keep_always</allow_active>
+    </defaults>
+  </action>
+
+  <action id="org.freedesktop.network-manager-settings.user.vpn.apply-with-share">
+    <description>Apply user vpn connections</description>
+    <message>System policy prevents using of user vpn connections</message>
+    <vendor>NetworkManager Novell Inc.</vendor>
+    <defaults>
+      <allow_inactive>no</allow_inactive>
+      <allow_active>auth_admin_keep_always</allow_active>
+    </defaults>
+  </action>
+
+  <action id="org.freedesktop.network-manager-settings.user.dsl.apply-with-share">
+    <description>Apply user dsl connections</description>
+    <message>System policy prevents using of user dsl connections</message>
+    <vendor>NetworkManager Novell Inc.</vendor>
+    <defaults>
+      <allow_inactive>no</allow_inactive>
+      <allow_active>auth_admin_keep_always</allow_active>
+    </defaults>
+  </action>
+
 </policyconfig>